# HG changeset patch
# User David Miguel Susano Pinto <carandraug@octave.org>
# Date 1652877157 -3600
#      Wed May 18 13:32:37 2022 +0100
# Node ID 7b12a031781ff4b6734be0ae81d20efceb078e61
# Parent  81b51b8236631eafe44d3e09e71a66255e800fe8
scripts/help/__unimplemented__.m: update list for image package (bug #62362)

diff -r 81b51b823663 -r 7b12a031781f scripts/help/__unimplemented__.m
--- a/scripts/help/__unimplemented__.m	Tue May 17 14:38:40 2022 -0700
+++ b/scripts/help/__unimplemented__.m	Wed May 18 13:32:37 2022 +0100
@@ -270,64 +270,150 @@ function txt = __unimplemented__ (fcn)
       txt = check_package (fcn, "financial");
 
     ## image processing
-    case {"activecontour", "adapthisteq", "affine2d", "affine3d", ...
-          "analyze75info", "analyze75read", "applycform", "applylut", ...
-          "axes2pix", "bestblk", "blockproc", "bwarea", "bwareaopen", ...
-          "bwboundaries", "bwconncomp", "bwconvhull", "bwdist", ...
-          "bwdistgeodesic", "bweuler", "bwhitmiss", "bwlabel", "bwlabeln", ...
-          "bwlookup", "bwmorph", "bwpack", "bwperim", "bwselect", ...
-          "bwtraceboundary", "bwulterode", "bwunpack", "checkerboard", ...
-          "col2im", "colfilt", "conndef", "convmtx2", "corner", ...
-          "cornermetric", "corr2", "cp2tform", "cpcorr", "cpselect", ...
-          "cpstruct2pairs", "dct2", "dctmtx", "deconvblind", "deconvlucy", ...
-          "deconvreg", "deconvwnr", "decorrstretch", "demosaic", ...
-          "edge", "edgetaper", "entropy", "entropyfilt", "fan2para", ...
-          "fanbeam", "findbounds", "fitgeotrans", "fliptform", "freqz2", ...
-          "fsamp2", "fspecial", "ftrans2", "fwind1", "fwind2", "getheight", ...
-          "getimage", "getimagemodel", "getline", "getneighbors", ...
-          "getnhood", "getpts", "getrect", "getsequence", "graycomatrix", ...
-          "graycoprops", "graydist", "grayslice", "graythresh", "hdrread", ...
-          "hdrwrite", "histeq", "hough", "houghlines", "houghpeaks", ...
-          "iccfind", "iccread", "iccroot", "iccwrite", "idct2", "ifanbeam", ...
-          "im2bw", "im2col", "im2double", "im2int16", "im2java2d", ...
+    case {"ImageAdapter", "activecontour", "adapthisteq", "adaptthresh", ...
+          "addPix2PixHDLocalEnhancer", "affine2d", "affine3d", ...
+          "affineOutputView", "analyze75info", "analyze75read", ...
+          "anomalyRX", "applycform", "applylut", "axes2pix", "bestblk", ...
+          "bfscore", "bigimage", "blendexposure", "blockLocationSet",
+          "blockedImage", "blockedImageDatastore", "blockedNetwork", ...
+          "blockproc", "boundarymask", ...
+          "brisque", "brisqueModel", "burstinterpolant", "bwarea", ...
+          "bwareafilt", "bwareaopen", "bwboundaries", "bwconncomp", ...
+          "bwconvhull", "bwdist", "bwdistgeodesic", "bweuler", "bwferet", ...
+          "bwhitmiss", "bwlabel", "bwlabeln", "bwlookup", "bwmorph", ...
+          "bwmorph3", "bwpack", "bwperim", "bwpropfilt", "bwselect", ...
+          "bwselect3", "bwskel", "bwtraceboundary", "bwulterode", ...
+          "bwunpack", "camresponse", "centerCropWindow2d", ...
+          "centerCropWindow3d", "checkerboard", "chromadapt", "col2im", ...
+          "colfilt", "colorChecker", "colorThresholder", "colorangle", ...
+          "colorcloud", "conndef", "convmtx2", "corner", "cornermetric", ...
+          "corr2", "correctOOB", "countEndmembersHFC", "cp2tform", ...
+          "cpcorr", "cpselect", "cpstruct2pairs", "cycleGANGenerator", ...
+          "dct2", "dctmtx", "deconvblind", "deconvlucy", "deconvreg", ...
+          "deconvwnr", "decorrstretch", "deltaE", "demosaic", ...
+          "denoiseImage", "denoiseNGMeet", "denoisingImageDatastore", ...
+          "denoisingImageSource", "denoisingNetwork", ...
+          "depthToSpace", "dice", ...
+          "displayColorPatch", "dlresize", "dn2radiance", "dn2reflectance", ...
+          "dnCNNLayers", "dpxinfo", "dpxread", "drawassisted", ...
+          "drawcircle", "drawcrosshair", "drawcuboid", "drawellipse", ...
+          "drawfreehand", "drawline", "drawpoint", "drawpolygon", ...
+          "drawpolyline", "drawrectangle", "edge", "edge3", "edgetaper", ...
+          "empiricalLine", "encoderDecoderNetwork", "entropy", ...
+          "entropyfilt", "enviinfo", "esfrChart", ...
+          "estimateAbundanceLS", "fan2para", ...
+          "fanbeam", "fastInScene", "fibermetric", "findbounds", "fippi", ...
+          "fitbrisque", "fitgeotrans", "fitniqe", "flatField", "fliptform", ...
+          "freqz2", "fsamp2", "fspecial", "fspecial3", "ftrans2", "fwind1", ...
+          "fwind2", "gabor", "geometricTransform2d", ...
+          "geometricTransform3d", "getimage", "getimagemodel", "getline", ...
+          "getnhood", "getpts", "getrect", "grabcut", "gradientweight", ...
+          "gray2ind", "graycomatrix", "grayconnected", "graycoprops", ...
+          "graydiffweight", "graydist", "grayslice", "graythresh", ...
+          "hdrread", "hdrwrite", "histeq", "hough", "houghlines", ...
+          "houghpeaks", "hypercube", "hypermnf", "hyperpca", ...
+          "hyperspectralViewer", "iarr", "iccfind", "iccread", "iccroot", ...
+          "iccwrite", "idct2", "ifanbeam", "illumgray", "illumpca", ...
+          "illumwhite", "im2bw", "im2col", "im2int16", "im2java2d", ...
           "im2single", "im2uint16", "im2uint8", "imabsdiff", "imadd", ...
-          "imadjust", "ImageAdapter", "imageinfo", "imapplymatrix", ...
-          "imapprox", "imattributes", "imbothat", "imclearborder", ...
-          "imclose", "imcolormaptool", "imcomplement", "imcontour", ...
-          "imcontrast", "imcrop", "imdilate", "imdisplayrange", ...
-          "imdistline", "imdivide", "imellipse", "imerode", "imextendedmax", ...
-          "imextendedmin", "imfill", "imfilter", "imfindcircles", ...
-          "imfreehand", "imfuse", "imgca", "imgcf", "imgetfile", ...
-          "imgradient", "imgradientxy", "imhandles", "imhist", ...
-          "imhistmatch", "imhmax", "imhmin", "imimposemin", "imlincomb", ...
-          "imline", "immagbox", "immovie", "immultiply", "imnoise", ...
-          "imopen", "imoverview", "imoverviewpanel", "impixel", ...
-          "impixelinfo", "impixelinfoval", "impixelregion", ...
-          "impixelregionpanel", "implay", "impoint", "impoly", "improfile", ...
-          "impyramid", "imquantize", "imreconstruct", "imrect", "imref2d", ...
-          "imref3d", "imregconfig", "imregionalmax", "imregionalmin", ...
-          "imregister", "imregtform", "imresize", "imroi", "imrotate", ...
-          "imsave", "imscrollpanel", "imsharpen", "imshowpair", ...
-          "imsubtract", "imtool", "imtophat", "imtransform", "imwarp", ...
-          "interfileinfo", "interfileread", "intlut", "iptaddcallback", ...
-          "iptcheckconn", "iptcheckhandle", "iptgetapi", ...
-          "iptGetPointerBehavior", "iptgetpref", "ipticondir", ...
-          "iptPointerManager", "iptprefs", "iptremovecallback", ...
-          "iptSetPointerBehavior", "iptsetpref", "iptwindowalign", "iradon", ...
-          "isflat", "isicc", "isrset", "lab2double", "lab2uint16", ...
-          "lab2uint8", "label2rgb", "labelmatrix", "makecform", ...
-          "makeConstrainToRectFcn", "makehdr", "makelut", "makeresampler", ...
-          "maketform", "mat2gray", "mean2", "medfilt2", "montage", ...
-          "multithresh", "nitfinfo", "nitfread", "nlfilter", "normxcorr2", ...
-          "openrset", "ordfilt2", "otf2psf", "padarray", "para2fan", ...
-          "phantom", "poly2mask", "projective2d", "psf2otf", "qtdecomp", ...
-          "qtgetblk", "qtsetblk", "radon", "rangefilt", "reflect", ...
-          "regionprops", "rgb2gray", "rgb2ycbcr", "roicolor", "roifill", ...
-          "roifilt2", "roipoly", "rsetwrite", "std2", "stdfilt", "strel", ...
-          "stretchlim", "subimage", "tformarray", "tformfwd", "tforminv", ...
-          "tonemap", "translate", "truesize", "viscircles", "warp", ...
-          "watershed", "whitepoint", "wiener2", "xyz2double", "xyz2uint16", ...
-          "ycbcr2rgb"}
+          "imadjust", "imadjustn", "imageBatchProcessor", "imageBrowser", ...
+          "imageRegionAnalyzer", "imageSegmenter", ...
+          "imageinfo", "imagemodel", "images.blocked.BINBlocks", ...
+          "images.blocked.GenericImage", ...
+          "images.blocked.GenericImageBlocks", "images.blocked.H5", ...
+          "images.blocked.H5Blocks", "images.blocked.InMemory", ...
+          "images.blocked.JPEGBlocks", "images.blocked.MATBlocks", ...
+          "images.blocked.PNGBlocks", "images.blocked.TIFF", ...
+          "images.geotrans.LocalWeightedMeanTransformation2D", ...
+          "images.geotrans.PiecewiseLinearTransformation2D", ...
+          "images.geotrans.PolynomialTransformation2D", ...
+          "images.geotrans.Warper", ...
+          "images.roi.AssistedFreehand", "images.roi.Circle", ...
+          "images.roi.Crosshair", "images.roi.Cuboid", ...
+          "images.roi.Ellipse", "images.roi.Freehand", "images.roi.Line", ...
+          "images.roi.Point", "images.roi.Polygon", "images.roi.Polyline", ...
+          "images.roi.Rectangle", "images.spatialref.Cuboid", ...
+          "images.spatialref.Rectangle", ...
+          "imapplymatrix", "imattributes", "imbilatfilt", "imbinarize", ...
+          "imbothat", "imboxfilt", "imboxfilt3", "imclearborder", ...
+          "imclose", "imcolordiff", "imcolormaptool", "imcomplement", ...
+          "imcontour", "imcontrast", "imcrop", "imcrop3", "imdiffuseest", ...
+          "imdiffusefilt", "imdilate", "imdisplayrange", "imdistline", ...
+          "imdivide", "imellipse", "imerase", ...
+          "imerode", "imextendedmax", "imextendedmin", "imfill", ...
+          "imfilter", "imfindcircles", "imflatfield", "imfreehand", ...
+          "imfuse", "imgaborfilt", "imgaussfilt", "imgaussfilt3", "imgca", ...
+          "imgcf", "imgetfile", "imgradient", "imgradient3", ...
+          "imgradientxy", "imgradientxyz", "imguidedfilter", "imhandles", ...
+          "imhist", "imhistmatch", "imhistmatchn", "imhmax", "imhmin", ...
+          "imimposemin", "imlincomb", "imline", "imlocalbrighten", ...
+          "immagbox", "immovie", "immse", "immultiply", "imnlmfilt", ...
+          "imnoise", "imopen", "imoverlay", "imoverview", ...
+          "imoverviewpanel", "impixel", "impixelinfo", "impixelinfoval", ...
+          "impixelregion", "impixelregionpanel", "implay", "impoint", ...
+          "impoly", "improfile", "imputfile", "impyramid", "imquantize", ...
+          "imreconstruct", "imrect", "setFixedAspectRatioMode", ...
+          "imreducehaze", "imref2d", ...
+          "imref3d", "imregconfig", "imregcorr", "imregdemons", ...
+          "imregionalmax", "imregionalmin", "imregister", "imregmtb", ...
+          "imregtform", "imresize3", "imroi", ...
+          "imrotate", "imrotate3", "imsave", "imscrollpanel", "imsegfmm", ...
+          "imseggeodesic", "imsegkmeans", "imsegkmeans3", "imsharpen", ...
+          "imshow", "imshowpair", "imsplit", "imsubtract", "imtool", ...
+          "imtophat", "imtransform", "imtranslate", "imwarp", "ind2gray", ...
+          "inpaintCoherent", "inpaintExemplar", "integralBoxFilter", ...
+          "integralBoxFilter3", "integralImage", "integralImage3", ...
+          "interfileinfo", "interfileread", "intlut", "inverseProjection", ...
+          "iptGetPointerBehavior", "iptPointerManager", ...
+          "iptSetPointerBehavior", "iptaddcallback", "iptcheckconn", ...
+          "iptcheckhandle", "iptcheckinput", "iptcheckmap", ...
+          "iptchecknargin", "iptcheckstrs", "iptdemos", "iptgetapi", ...
+          "iptgetpref", "ipticondir", "iptnum2ordinal", "iptprefs", ...
+          "iptremovecallback", "iptsetpref", "iptwindowalign", "iradon", ...
+          "isicc", "isnitf", "isrset", "jaccard", "jitterColorHSV", ...
+          "jmsam", "lab2double", "lab2rgb", "lab2uint16", "lab2uint8", ...
+          "lab2xyz", "label2idx", "label2rgb", "labelmatrix", ...
+          "labeloverlay", "labelvolshow", ...
+          "lazysnapping", "lin2rgb", "localcontrast", "locallapfilt", ...
+          "localtonemap", "logResiduals", "makeConstrainToRectFcn", ...
+          "makecform", "makehdr", "makelut", "makeresampler", "maketform", ...
+          "mat2gray", "maxhessiannorm", "mean2", "medfilt2", "medfilt3", ...
+          "modefilt", "montage", "multissim", "multissim3", "multithresh", ...
+          "ndvi", "nfindr", "niftiinfo", "niftiread", "niftiwrite", "niqe", ...
+          "niqeModel", "nitfinfo", "nitfread", "nlfilter", ...
+          "normxcorr2", "ns3", "ntsc2rgb", "obliqueslice", "offsetstrel", ...
+          "openrset", "ordfilt2", "orthosliceViewer", ...
+          "otf2psf", "otsuthresh", ...
+          "padarray", "para2fan", "patchGANDiscriminator", "phantom", ...
+          "piqe", "pix2pixHDGlobalGenerator", "planar2raw", ...
+          "plotChromaticity", "plotSFR", "poly2label", "poly2mask", ...
+          "polyToBlockedImage", "ppi", "pretrainedEncoderNetwork", ...
+          "projective2d", "psf2otf", "psnr", "qtdecomp", "qtgetblk", ...
+          "qtsetblk", "radiance2Reflectance", "radon", "randomAffine2d", ...
+          "randomAffine3d", "randomCropWindow2d", "randomCropWindow3d", ...
+          "randomPatchExtractionDatastore", "randomWindow2d", ...
+          "rangefilt", "raw2planar", "raw2rgb", "rawinfo", "rawread", ...
+          "readEcostressSig", "reduceSmile", "reducepoly", "regionfill", ...
+          "regionprops", "regionprops3", ...
+          "registration.metric.MattesMutualInformation", ...
+          "registration.metric.MeanSquares", ...
+          "registration.optimizer.OnePlusOneEvolutionary", ...
+          "registration.optimizer.RegularStepGradientDescent", ...
+          "registrationEstimator", "rgb2lab", "rgb2lightness", "rgb2lin", ...
+          "rgb2ntsc", "rgb2xyz", "rgb2ycbcr", "rgbwide2xyz", ...
+          "rgbwide2ycbcr", "rigid2d", "rigid3d", "roicolor", "roifill", ...
+          "roifilt2", "roipoly", "rrs", "rsetwrite", "sam", ...
+          "selectBlockLocations", "sharc", "sharpencnmf", "sid", "sidsam", ...
+          "sliceViewer", "smileMetric", ...
+          "spaceToDepth", "spectralIndices", "spectralMatch", "ssim", ...
+          "std2", "stdfilt", "strel", "stretchlim", "subimage", ...
+          "subtractDarkPixel", "superpixels", "superpixels3", "tformarray", ...
+          "tformfwd", "tforminv", "tiffreadVolume", "tonemap", ...
+          "tonemapfarbman", "truesize", "unitGenerator", "unitPredict", ...
+          "visboundaries", "viscircles", "volshow", ...
+          "volumeSegmenter", "volumeViewer", "warp", "watershed", ...
+          "whitepoint", "wiener2", "xyz2double", "xyz2lab", "xyz2rgb", ...
+          "xyz2rgbwide", "xyz2uint16", "ycbcr2rgb", "ycbcr2rgbwide"}
       txt = check_package (fcn, "image");
 
     ## signal processing